
class BaseScroller(object):
    def __init__(self):
        self.surface = None
        self.speed = [0, 0]
        self.screen = None
        self.rect = None
        self.background = None
        self.finished = False
        
    def set_screen(self, screen):
        self.screen = screen
        self.screen_size = self.screen.get_size()
        
    def set_background(self, background):
        self.background = background
        
    def set_surface(self, surface):
        self.surface = surface

    def get_rect(self):
        return self.surface.get_rect()

    def set_speed(self, speed):
        self.speed = speed

    def move(self):
        self.oldrect = self.rect
        self.rect = self.rect.move(self.speed)

    def scroll(self):
        self._scroll()
        # assuming right to left scroll here
        if self.rect.right <= 0:
            self.finished = True
        # return the rect areas that have been changed
        return [self.oldrect, self.rect]

    def _scroll(self):
        self.move()
        # we really need to calculate a new rect from old and new
        # and just blit that part of the background instead of doing
        # it twice (although doing it twice is quicker than blitting the
        # whole background once).
        #print self.rect, self.oldrect

        #self.screen.blit(self.background, self.rect, self.rect)

        #rect = pygame.Rect(self.rect)
        #rect.union(self.oldrect)

        #self.screen.blit(self.background, self.oldrect, self.oldrect)

        #self.screen.blit(self.background, rect, rect)

        #self.screen.blit(self.surface, self.rect)
        
    def scroll_right_to_left_offscreen(self):
        self._scroll()
        if self.rect.right <= 0:
            self.finished = True
        # return the rect areas that have been changed
        return [self.oldrect, self.rect]

    def scroll_right_to_left_onscreen(self):
        self._scroll()
        if self.rect.left <= 0:
            self.finished = True
        return [self.oldrect, self.rect]

    def scroll_left_to_right_offscreen(self):
        self._scroll()
        if self.rect.left >= self.screen_size[0]:
            self.finished = True
        return [self.oldrect, self.rect]

    def scroll_left_to_right_onscreen(self):
        self._scroll()
        if self.rect.right >= self.screen_size[0]:
            self.finished = True
            return [self.oldrect, self.rect]
        
        
if __name__ == '__main__':
    pass

    
