import pygame

from basescroll import BaseScroller

# this class helps hold the font along
# with the text and color
class BaseFontObject(object):
    def __init__(self):
        self.font = None
        self.color = None
        self.text = None
        
    def set_sysfont(self, name, size):
        self.font = pygame.font.SysFont(name, size)

    def set_font_file(self, filename, size):
        self.font =  pygame.font.Font(filename, size)
        
    def set_color(self, color):
        self.color = color

    def set_text(self, text):
        self.text = text
        
    def set_bold(self, bold):
        self.font.set_bold(bold)

    def set_italic(self, italic):
        self.font.set_italic(italic)

    def set_underline(self, underline):
        self.font.set_underline(underline)
        

class TextScroller(BaseScroller, BaseFontObject):
    def __init__(self):
        BaseFontObject.__init__(self)
        BaseScroller.__init__(self)
        
    def make_surface(self):
        self.surface = self.font.render(self.text, True, self.color)

# We're not doing anything with the sprites yet.
class TextSprite(pygame.sprite.Sprite, BaseFontObject):
    def __init__(self):
        BaseFontObject.__init__(self)
        pygame.sprite.Sprite.__init__(self)
        self.color = (0, 0, 0)
        
    def make_surface(self):
        self.image = self.font.render(self.text, True, self.color)
        self.rect = self.image.get_rect()


        
